/*jslint undef: true, widget: true, browser: true, onevar: true, eqeqeq: true */
/*global YAHOO,
         iw_form,
         iw_xhr
*/

var iw_sw_ipv6_suggester = {
    responder: 'IPv6Suggester',

    handle201: function ( r, input ) {
        iw_form.clearStatus(input);
        input.value = r.getReplyData();
        input.disabled = 0;
    },

    handle600series: function ( r, input ) {
      // Just move along, nothing to see here.
        iw_form.clearStatus(input);
        input.disabled = 0;
    },

    execute : function () {
        var input = document.forms.siteworx_account_management.master_domain_ipv6_from_pool;

        if ( this.value === '0' ) {
            return;
        }

        iw_form.markPending(input);
        input.disabled = 1;

        iw_xhr.getReply(iw_sw_ipv6_suggester, encodeURIComponent(this.value), input);
    },

    init: function () {
        YAHOO.util.Event.on(
            document.forms.siteworx_account_management.ipv6_pool,
            'change',
            this.execute
        );
    }
};

iw_sw_ipv6_suggester.init();

/**
 * Handler for the unix user suggestion
 */
var iw_sw_uu_suggester = {
    responder :'UnixuserSuggester',

  /**
   * Fills in the suggestion from the responder
   *
   * @param object r
   * @param HTMLElement uniqname
   */
    handle201 : function ( r, uniqname ) {
        iw_form.clearStatus(uniqname);

        uniqname.value    = r.getReplyData();
        uniqname.disabled = 0;
    },

  /**
   * Clears the status for when the domain was blank
   *
   * @param object r
   * @param HTMLElement uniqname
   */
    handle699 : function ( r, uniqname ) {
        iw_form.clearStatus(uniqname);
        uniqname.disabled = 0;
        return;
    },

  /**
   * Clears the status when the domain was invalid
   *
   * @param object r
   * @param HTMLElement uniqname
   */
    handle698 : function ( r, uniqname ) {
        iw_sw_uu_suggester.handle699(r, uniqname);
    },

    execute : function () {
        var uniqname = document.forms.siteworx_account_management.uniqname;

        if ( this.value === '' ) {
            return;
        }

        iw_form.markPending(uniqname);
        uniqname.disabled = 1;

        iw_xhr.getReply(iw_sw_uu_suggester, this.value, uniqname);
    }
};

if ( document.getElementById('siteworx_account_management-shell') ) {
    YAHOO.util.Event.delegate(
        document.getElementById('siteworx_account_management-shell'),
        'focusout',
        iw_sw_uu_suggester.execute,
        'input[name=master_domain]'
    );
}

/**
 * Handler for the SiteWorx package Add/Edit screen's package template chooser
 */
var iw_sw_package_template_handler = {
    responder :'SWPackageTemplate',

  /**
   * Ok result
   */
    handle201 : function ( r, selectbox ) {
        var result = r.getReplyData(), option, optname, value, input;

        iw_form.clearStatus(selectbox);

      // Loop through all the options, and set the correct values
        for (option in result) {
            if ( result.hasOwnProperty(option) ) {
                if (option.substr(0,3) == 'LG_') {
                    optname = option.substr(3);
                } else {
                    optname = option;
                }
                value   = result[option];
                input   = document.forms.siteworx_account_management[ optname ];

                if (input) {
                    if ( value === true ) {
                        input.selectedIndex = 0;
                    } else if ( value === false ) {
                        input.selectedIndex = 1;
                    } else {
                        input.value = value;
                        if ( YAHOO.lang.isUndefined(iw_form.inputPropertyCache[optname]) === false ) {
                            iw_form.inputPropertyCache[optname].value = value;
                        }
                    }
                    // We assume if it came from package info, then it's going to be valid
                    // Don't do "round trip" validation
                    iw_form.markValid(input);
                }
            }
        }//end for

      // triggers the unlimited animation if needed
        iw_form.initUnlimited();
        iw_form.initShowSelect();
    },

  /**
   * Fires off the xhr request to get the package info if a package is selected.
   */
    execute : function () {
        var selectobj = document.forms.siteworx_account_management.packagetemplate, package_id = selectobj.options[selectobj.selectedIndex].value, input = {
            id :package_id,
            domain : document.forms.siteworx_account_management.domain ? document.forms.siteworx_account_management.domain.value : '',
            reseller_id :document.forms.siteworx_account_management.reseller ? document.forms.siteworx_account_management.reseller.value : ''
        };
        if ( package_id !== '' ) {
            iw_form.markPending(this);
            iw_xhr.getReply(iw_sw_package_template_handler, input, this);
        }
    }
};

// handle the package template change event
YAHOO.util.Event.on(
    document.forms.siteworx_account_management.packagetemplate,
    'change',
    iw_sw_package_template_handler.execute
);

(function () {
    var ipv4_input = document.forms.siteworx_account_management.master_domain_ipv4,
      additional_ipv4 = document.forms.siteworx_account_management['additional_ipv4[]'];
    YAHOO.util.Event.on(ipv4_input, 'change', function () {
        iw_form.setValue(additional_ipv4, iw_form.getValue(this));
    });
})();

(function () {
    var ipv6_input = document.forms.siteworx_account_management.master_domain_ipv6,
      additional_ipv6 = document.forms.siteworx_account_management['additional_ipv6[]'];
    YAHOO.util.Event.on(ipv6_input, 'change', function () {
        iw_form.setValue(additional_ipv6, iw_form.getValue(this));
    });
})();
